local subTag = "pb_"

--sub tags para poder iniciar os recursos. EXP: (tag_resource) ficaria subTag .. "tag",
local importantResources = {
    subTag .. "scr",  
}

local excludeResources = {}
for k,v in pairs(importantResources) do
    excludeResources[v] = true
end

local threadTimer
local threads = {}
local load_speed = 1000 -- segundos para carregar os recursos
local load_speed_multipler = 1 -- recursos carregados por vez
local canConnect = false

addEventHandler("onResourceStart", resourceRoot,
    function()
        if not getElementData(root, "loadedAllRes") then
            setElementData(root, "loadedAllRes", true)
            for k, v in ipairs(importantResources) do
                local res = getResourceFromName(v)
                if res then
                    table.insert(threads, res)
                end
            end

            for k,v in pairs(getResources()) do
                if v ~= getThisResource() then
                    local subText = utfSub(getResourceName(v), 1, #subTag)
                    if subText == subTag and not excludeResources[getResourceName(v)] then 
                        table.insert(threads, v)
                    end
                end
            end

            threadTimer = setTimer(
                function()
                    local num = 0

                    for k,v in pairs(threads) do
                        num = num + 1

                        if num > load_speed_multipler then
                            break
                        end

                        startResource(v)

                        table.remove(threads, k)

                        outputDebugString(getResourceName(v).. " resource has started!", 2)
                    end

                    if num == 0 then
                        killTimer(threadTimer)
                        outputDebugString("All resource started!", 3)
                        threadTimer = nil
                        canConnect = true
                    end
                end, load_speed, 0 
            )
        end
    end
)

addEventHandler("onPlayerConnect", root,
    function()
        if not canConnect then
            cancelEvent(true, "SeuServer\n O Servidor está carregando!")
        end
    end
)